//
//  BFCustomMusicBtn.swift
//  BFRecordScreenKit
//
//  Created by Harry on 2022/3/4.
//

import Foundation
import Kingfisher


class BFCustomMusicBtn : UIView {
    var title : String = ""
    var img : UIImage?
    
    var clickAction : (() -> Void)?
    
    fileprivate var titleL = UILabel()
    fileprivate var imageV = UIImageView(image: imageInRecordScreenKit(by: "addmusic"))
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        titleL.font = UIFont.systemFont(ofSize: 13)
        titleL.text = "选择音乐"
        titleL.textColor = UIColor.white
        titleL.textAlignment = .left
        titleL.lineBreakMode = .byTruncatingTail
        
        imageV.layer.cornerRadius = 16
        imageV.layer.masksToBounds = true
        
        addSubview(imageV)
        addSubview(titleL)
        
        
        imageV.snp.makeConstraints { make in
            make.left.equalTo(6)
            make.right.equalTo(titleL.snp.left).offset(-4)
            make.top.equalTo(3)
            make.bottom.equalTo(-3)
            make.width.equalTo(imageV.snp.height)
            make.centerY.equalToSuperview()
        }
        
        titleL.snp.makeConstraints { make in
            make.left.equalTo(imageV.snp.right).offset(4)
            make.right.equalTo(-8)
            make.top.equalTo(2)
            make.bottom.equalTo(-2)
            make.centerY.equalToSuperview()
            make.width.lessThanOrEqualTo(200)
        }
        
        let btn = UIButton()
        btn.addTarget(self, action: #selector(click), for: .touchUpInside)
        addSubview(btn)
        btn.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    @objc func click() {
        clickAction?()
    }
    
    func config(title:String? = "选择音乐", imgUrl:URL? = nil){
        titleL.text = title ?? "选择音乐"
        if imgUrl == nil {
            imageV.image = imageInRecordScreenKit(by: "addmusic")
        }else {
            imageV.kf.setImage(with: imgUrl)
        }
        
        setNeedsLayout()
        layoutIfNeeded()
        
    }
}
